<?php
/**
 * Created by PhpStorm.
 * User: João
 * Date: 21/06/2015
 * Time: 02:05
 *
 * Some notes:
 * Since I'm not using controllers (you will actually notice that the helpers dir is directly in the root),
 * this file will work as one to run the test case
 */

/**
 * Ugly include list for all models and helpers, a framework would do it all
 */
include 'helpers/CommunicationsHelper.php';
include 'helpers/MathHelper.php';
include 'models/BillingType.php';
include 'models/Client.php';
include 'models/PaymentMethod.php';

/**
 * I could have put the setters directly on the constructor but I believe that doing it this way
 * makes it more obvious for other devs that these properties can be changed this easily.
 * If there was a DB these would probably be fields of the Clients table, the constructor
 * would only take an ID and the getters for billing types and payment methods would be factories.
 */

try {
    $client = new Client('Nimrod', 'nimrod@imaginecurve.com');
    $client->setBillingType(new HourlyBilling());
    $client->setPaymentMethod(new MailPayment());
    $client->setBillingRate(500);
    $client->bill(array('days' => array(MathHelper::random(5, 9), // Monday
                                        MathHelper::random(5, 9), // Tuesday
                                        MathHelper::random(5, 9), // Wednesday
                                        MathHelper::random(5, 9), // Thursday
                                        MathHelper::random(5, 9)))); // Friday
} catch (Exception $e) {
    echo $e->getMessage();
}

/**
try {
    $client2 = new Client('Joao', 'joao@imaginecurve.com');
    $client2->setBillingType(new MonthlyBilling());
    $client2->setPaymentMethod(new HandDeliveryPayment());
    $client2->setBillingRate(5000);
    $client2->bill();
} catch (Exception $e) {
    echo $e->getMessage();
}
*/

/**
try {
    $client3 = new Client('Anna', 'anna@imaginecurve.com');
    $client3->setBillingType(new ProjectBilling());
    $client3->setPaymentMethod(new DirectDepositPayment());
    $client3->setBillingRate(5000);
    $client3->bill(array('projectValue'=>10000));
} catch (Exception $e) {
    echo $e->getMessage();
}*/