<?php
/**
 * Created by PhpStorm.
 * User: João
 * Date: 21/06/2015
 * Time: 00:17
 */

class ProjectBilling implements BillingType {
    private $_baseRate;

    /**
     * Returns the amount to charge a client
     * @param array $billingData
     * @throws Exception
     * @return float
     */
    public function calculate($billingData = array())
    {
        /**
         * 5% of project worth + base monthly payment (which is why there needs to be a 'projectValue' index)
         */
        if (!isset($billingData['projectValue']))
            throw new Exception('Invalid billing data provided.
                                You need to specify the value of the project.');
        return 0.05*$billingData['projectValue'] + $this->getBaseRate();
    }

    /**
     * Defines the base value to use as rate for later calculations
     * @param float $value
     */
    public function setBaseRate($value) {
        $this->_baseRate = $value;
    }

    /**
     * @return float
     */
    public function getBaseRate() {
        return $this->_baseRate;
    }
}